local ADDON = ...
local tooltip
local arg = {}

local smv

local LibQTip = LibStub('LibQTip-1.0')
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
 
local dataobj = ldb:NewDataObject(ADDON, {
    type = "data source",
    icon = "Interface\\Addons\\"..ADDON.."\\icon.tga",
    text = "-"
}) 

local frame = CreateFrame("Frame")

local function UpdateLDB()
	smv = string.format("%.1f",C_CVar.GetCVar("Sound_MasterVolume"))
	dataobj.text = smv
	
	if C_CVar.GetCVar("Sound_EnableAllSound") == "1" then 
		dataobj.icon = "Interface\\Addons\\"..ADDON.."\\icon.tga"
	else
		dataobj.icon = "Interface\\Addons\\"..ADDON.."\\icon-off.tga"
	end
end

function dataobj.OnClick(self, button)

	-- if InCombatLockdown() then return end
	
	smv = string.format("%.1f",GetCVar("Sound_MasterVolume"))
	
	LibQTip:Release(self.tooltip)
	self.tooltip = nil

	if button ~= "MiddleButton" then

		if button == "LeftButton" then	
			smv = smv - 0.1
			if smv < 0 then 
				smv = 0			
			end
		end

		if button == "RightButton" then	
			smv = smv + 0.1
			if smv > 1 then 
				smv = 1
			end
		end
		
		C_CVar.SetCVar("Sound_MasterVolume", smv)
		print(string.format("|cFFFFFF00%s|r : Master Volume is now %s",ADDON,smv))	
	
	else
			if C_CVar.GetCVar("Sound_EnableAllSound") == "0" then
				C_CVar.SetCVar("Sound_EnableAllSound", "1")
				print(string.format("|cFFFFFF00%s|r : All Sounds are ON",ADDON))
			else 
				C_CVar.SetCVar("Sound_EnableAllSound", "0")
				print(string.format("|cFFFFFF00%s|r : All Sounds are OFF",ADDON))
			end	
	end
	
	UpdateLDB()
end

frame:RegisterEvent('CVAR_UPDATE')
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:SetScript("OnEvent", function(self, event, arg1, ...)
	if event == "CVAR_UPDATE" or event == "PLAYER_ENTERING_WORLD" then
		UpdateLDB()  	
	end
end)	